<?php

//-----------------------------------------------------------------------------------
function get_file_contents($f)
{    
  ob_start();
  $retval = @readfile($f);
  if (false !== $retval)
  { // no readfile error
      $retval = ob_get_contents();
  }
  ob_end_clean();
  return $retval;
}
//-----------------------------------------------------------------------------------
function GetNodeIndex($Name)
{
  global $Root;

  //Iterate through the names until we find one that is not set.
  $Index = 0;

  $Temp = "\$Test=isset(\$Root->C->".$Name."[".$Index."]);";
  eval($Temp);
  while($Test)
  {    
    $Index++;
    $Temp = "\$Test=isset(\$Root->C->".$Name."[".$Index."]);";
    eval($Temp);    
  }
  
  return $Index;
}
//-----------------------------------------------------------------------------------
function GetNodeName($Name)
{
  $NodeIndex = GetNodeIndex($Name);
  $Temp = "\$Root->C->".$Name."[".$NodeIndex."]";   
  return $Temp;
}
//-----------------------------------------------------------------------------------
function AddNode($Name)
{
  global $Root;

  //It is possible that there may be many nodes with $Name for this current node.
  // That is why we need to find if one has already been added.
  $NodeName = GetNodeName($Name);  

  //Add the nodes parent.
  $Temp = $NodeName."->P=&\$Root->C;";
  eval($Temp);
  
  //Point current to the new node.
  $Temp = "\$Root->C = &".$NodeName.";";
  eval($Temp);
  
  //
  $Root->C->Name = $NodeName;
}
//-----------------------------------------------------------------------------------
function ElementStart($Parser, $Name, $Attribs)
{
  global $Root;
  //Create a new node and point the current node to it.
  AddNode($Name);
}
//-----------------------------------------------------------------------------------
function ElementEnd($Parser, $Name)
{
  global $Root;
  //Point the current node to it's parent.  
  $Root->C = &$Root->C->P;
}
//-----------------------------------------------------------------------------------
function ElementData($Parser, $Data)
{
  global $Root;
  if (isset($Root->C->Data))
  {
    //$Root->C->Data .= str_replace('\\xe9', 'e', $Data);
    $Root->C->Data .=$Data;
  }
  else
  {
    $Root->C->Data = $Data;
  }
}
//-----------------------------------------------------------------------------------
function Parse($XML)
{
  global $Root;
  $Root->P = &$Root;//P is the parent to $Root (Root has no parent).
  $Root->C = &$Root;//C is the current node.  (Root is empty so it points to itself.
  
  //Create an instance of the parser.
  $Parser = xml_parser_create(); 
  
  //Attach the parser element events.
  xml_set_element_handler($Parser, "ElementStart", "ElementEnd"); 

  //Attach the parser data event.
  xml_set_character_data_handler($Parser, "ElementData");  

  //Parse.
  if (!xml_parse($Parser, $XML))
  { 
    die(sprintf("XML error: %s at line %d", 
      xml_error_string(xml_get_error_code($xml_parser)), 
      xml_get_current_line_number($xml_parser))); 
  }   
  
  return $Root;
}
//-----------------------------------------------------------------------------------
function GXMLTree($FileName)
{
  $XML = get_file_contents($FileName);
  global $Root;
  $Root = "";  
  $Tree = Parse($XML);
  return $Tree;
}
//$XML = get_file_contents("http://xml.amazon.com/onca/xml3?t=thinkbling-20&dev-t=D11PEK22YBCZS3&AsinSearch=043935806X&type=heavy&f=xml");
//$XML = get_file_contents("http://xml.amazon.com/onca/xml2?t=thinkbling-20&dev-t=D11PEK22YBCZS3&mode=books&type=heavy&page=1&f=xml&KeywordSearch=Harry%20Potter&sort=+salesrank");
//$Tree = Parse($XML);

//echo($XML);

//-----------------------------------------------------------------------------------
?>